(defun c:secretaria () ;defeni a função no caso "secretária" ou seja uma mesa com um movel associado onde podemos escolher tanto o seu numero de prateleiras como altura, algura e profundidade
(setq pontos2d (getvar "osmode"))
(setq pontos3d (getvar "3dosmode"))
(setvar "osmode" 0)
(setvar "3dosmode" 0) ;Estes comandos salvam as configurações de "osmode" e "3dosmode" do usuário antes de mudá-las para 0 (2D) e 0 (não usar os eixos X, Y e Z), respectivamente

(setq pt1 (getpoint "indique o ponto de insercao: ")) ; Comando para o usuário selecionar o ponto de inserção do objeto para o modelo 3D

(If (= nil (setq comprimento (getreal " indique o comprimento da secretária (em x):")))
(setq comprimento 2.00)) ;Comando para o usuário indicar o comprimento da secretária em X. O Comprimento base será de 2.00. 

(If (= nil (setq largura (getreal "indique a largura (em y): ")))
(setq largura 0.90)) ; Comando para o usuário indicar a largura da secretária em Y. A largura base será 0.90.

(If (= nil (setq altura (getreal "indique a altura da secretaria (em z): ")))
(setq altura 0.80)) ; Comando para o usuário indicar a altura da secretária em Z. A altura base será de 0.80.

(If (= nil (setq espessura (getreal "indique a espessura dos tampos : ")))
(setq espessura 0.05)) ; comando para indicar a espessura do tampo dos vários tampos. A espessura base será de 0.05.

(If (= nil (setq comp2 (getreal "indique o comprimento da estante (em x): ")))
(setq comp2 0.60)) ;Comando para o usuário indicar o comprimento da estante em X. O Comprimento base será de 0.60. 

(If (= nil (setq alt2 (getreal "indique a altura da estante (em z): ")))
(setq alt2 0.80)) ; Comando para o usuário indicar a altura da estante em Z. A altura base será de 0.80.

(If (= nil (setq nop (getreal "indique o numero de prateleiras da estante: ")))
(setq nop 2)) ; Comando para o usuario indicar o numero de prateleiras da estante. Numero base será 2.

(If (= nil (setq espessura2 (getreal "indique a espessura das pernas: ")))
(setq espessura2 0.10)) ; Comando para o usuario indicar as espessura das pernas da secretaria. O valor base sera 0.10.

(setq alturaprat (/ (- alt2 (* (+ nop 2) espessura)) (+ nop 1))) ; comando para defenir a diferença de alturas entre prateleiras


(modelar) 
(setvar "osmode" pontos2d)
(setvar "3dosmode" pontos3d)
(command "ucs" "")
(command "shade")
) ; ucs redefine o sistema de coordenadas do usuário para o ponto de inserção da secretária, que foi definido anteriormente na função e shade ativa o sombreamento da visualização do desenho para torná-lo mais fácil de visualizar em 3D.

(defun modelar () ; aqui vai começar a modelagem do objeto, no caso a secretária.

(command "ucs" pt1 "") ; O comando define o sistema de coordenadas (UCS) para o ponto indicado pelo usuário na variável pt1.


(command "box" (list 0 0 espessura) (list comp2 largura 0))
(setq base (entlast)) ; O comando cria-nos um paralelepípedo correspondente à base do movel com comprimento,largura e espessura anteriormente defenidos, onde o ponto de origem é no canto inferior esquerdo (0,0,espessura). O paralelepípedo é na variável base.
perl


(command "box" (list 0 0 espessura) (list espessura largura (- alt2 espessura)))
(setq lateralesq (entlast)) ; O comando cria outro paralelepípedo corresspondente à trave lateral esquerda do movel, cujo ponto de origem está no canto inferior esquerdo (0,0,espessura). 

(command "box" (list (- comp2 espessura) 0 espessura) (list comp2 largura (- alt2 espessura)))
(setq lateraldir (entlast)) ; o comando cria-nos outro paralelepipedo corresspondente à trave lateral direita, para criar outra das prateleiras. são indicados os pontos para o criar.

(command "box" (list espessura 0 (+ espessura alturaprat)) (list (- comp2 espessura) largura (+ espessura alturaprat espessura)))
(setq prat1 (entlast)) ; o comando cria-nos outro paralelepipedo correspondente à primeira prateleira, onde o primeiro elemento é a posição do canto inferior esquerdo da caixa e o segundo elemento é a posição do canto superior direito da caixa, para criar outra das prateleiras. são indicados os pontos para o criar.


(command "box" (list 0 0 alt2) (list comp2 largura (- alt2 espessura)))
(setq topo (entlast)) ; o comando cria-nos outro paralelepipedo correspondente ao tampo do movel

(command "box" (list comp2 0 (- altura espessura)) (list (+ comp2 comprimento) largura altura))
(setq secret (entlast)) ; o comando cria-nos outro paralelepipedo correspondente ao tampo da secretaria

(command "box" (list (- (+ comprimento comp2) espessura2) 0 0) (list (+ comp2 comprimento) espessura2 (- altura espessura)))
(setq p1 (entlast)) ; o comando cria o primeiro pé da secretaria

(command "array" p1 "" "r" 2 1 (- largura espessura2))
(setq p2 (entlast)) ; o comando array copia-nos o primeiro pe da secretaria e cria o segundo

(command "UCS" (list 0 0 0) (list 1 0 0) (list 0 0 1)) ; o comando altera-nos os eixs do ucs, o eixo Z vai para Y. 

(command "array" prat1 "" "r" nop 1 (+ alturaprat espessura)) ; o comando cria uma matriz de cópias do objeto "prat1" ou seja prateleiras, que foi criado anteriormente como uma prateleira da estante. O "r" indica que a matriz é uma matriz retangular. A seguir indicam o número de linhas e colunas da matriz, respectivamente. Por ultimo é a distância entre as  várias cópias ou seja as prateleiras.

(command "union" base lateralesq lateraldir topo secret p1 p2 "") ; O comando une os objetos criados anteriormente: "base", "lateralesq", "lateraldir", "topo", "secret", "p1", "p2". Isto combina todos esses objetos num único objeto sólido. A última parte indica que não há grupos ou seleções adicionais a serem unidos.

;Após essa linha, o código finaliza a função "modelar" e volta à função principal "secretaria"

)